#ifndef CH16P1_IMAGEMANIPULATORKERNELS_H__DEFINED
#define CH16P1_IMAGEMANIPULATORKERNELS_H__DEFINED

#include "CommonFuncs.h"
#include "D3DHelperFuncs.h"
#include <vector>

class CImageManipulator;

class CImageManipulatorKernel
{
public:
  CImageManipulatorKernel() { }
  virtual ~CImageManipulatorKernel() { }

  virtual void ProcessPixel(D3DXCOLOR &finalcolor, CImageManipulator *manip) = 0;

protected:
  D3DXCOLOR ApplyKernelToPoint(D3DXCOLOR &finalcolor, int iKernelWidth, int iKernelHeight,
    CImageManipulator *manip);

  std::vector<float> m_KernelValues;
  int m_iWidth;
  int m_iHeight;
};

class CBlurKernel : public CImageManipulatorKernel
{
public:
  CBlurKernel();
  virtual ~CBlurKernel() { }

  void ProcessPixel(D3DXCOLOR &finalcolor, CImageManipulator *manip);

private:
};

class CExtraBlurKernel : public CImageManipulatorKernel
{
public:
  CExtraBlurKernel();
  virtual ~CExtraBlurKernel() { }

  void ProcessPixel(D3DXCOLOR &finalcolor, CImageManipulator *manip);

private:
};

class CSharpeningKernel : public CImageManipulatorKernel
{
public:
  CSharpeningKernel();
  virtual ~CSharpeningKernel() { }

  void ProcessPixel(D3DXCOLOR &finalcolor, CImageManipulator *manip);

private:
};

class CEdgeDetectionKernel : public CImageManipulatorKernel
{
public:
  CEdgeDetectionKernel();
  virtual ~CEdgeDetectionKernel() { }

  void ProcessPixel(D3DXCOLOR &finalcolor, CImageManipulator *manip);

private:
};

#endif 
