#include "Ch17p2_ConstSpeedMeltTransition.h"


void CConstSpeedMeltTransition::SetDuration(const float data) 
{ 
  CTransition::SetDuration(data);
  m_FallSpeed.m_Min = 2.0f / m_fDuration;
  m_FallSpeed.m_Max = 7.0f / m_fDuration;

  m_ColumnDropSpeed.clear();

  for (int q=0; q < m_iNumVertsX; q++) {
    m_ColumnDropSpeed.push_back(m_FallSpeed.GetRandomNumInRange());
  }
}

void CConstSpeedMeltTransition::DoTransition(float fTransTime)
{
  m_fFadeTime += fTransTime;

  HRESULT hr;
  VERTEX_XYZ_DIFFUSE_TEX1* pVertices; 
 
  if( FAILED( hr = m_pVBMelt->Lock( 0, m_iNumVertsX*m_iNumVertsY*sizeof(VERTEX_XYZ_DIFFUSE_TEX1), 
      (BYTE**)&pVertices, 0 ) ) )
    return;

  float fTotalSize = 2.0f;
  float fSizeDiv2 = fTotalSize / 2.0f;
  for (int x=0; x < m_iNumVertsX; x++) {
    for (int y=0; y < m_iNumVertsY; y++) {
      pVertices[(y*m_iNumVertsX)+x].position.y -= m_ColumnDropSpeed[x] * fTransTime;
    }
  }
  if(FAILED(hr = m_pVBMelt->Unlock())) return;
}

