#ifndef CH17P2_MELTTRANSITION_DEFINED
#define CH17P2_MELTTRANSITION_DEFINED

#include "Ch17p2_Transition.h"
#include "MinMax.h"

class CMeltTransition : public CTransition
{
public:
  CMeltTransition(LPDIRECT3DDEVICE8 pDev, LPDIRECT3DTEXTURE8 pOrigImage, LPDIRECT3DTEXTURE8 pNewImage,
    int iNumTilesX);
  virtual ~CMeltTransition();
  virtual void DoTransition(float fTransTime);
  void DoRender(D3DXMATRIX mFinalScale);

  virtual void SetDuration(const float data);
  
protected:
  float m_fFadeTime;
  int m_iNumVertsX, m_iNumVertsY;
  CMinMax<float> m_FallSpeed;
  
  LPDIRECT3DVERTEXBUFFER8 m_pVBQuad;
  LPDIRECT3DVERTEXBUFFER8 m_pVBMelt;
  LPDIRECT3DINDEXBUFFER8 m_pIBMelt;
  LPDIRECT3DTEXTURE8 m_pNewImage;

};

#endif