#include "AnimSequence.h"
#include "Ch21p1_Gun.h"
#include "Ch19p1_ParticleSystem.h"

class CLaserGun : public CGun
{
public:
	CLaserGun();
	virtual ~CLaserGun();

	virtual HRESULT RestoreDeviceObjects(LPDIRECT3DDEVICE8 pDev, const char *strMeshFilename);
  virtual void InvalidateDeviceObjects();

	virtual void Render(CCamera &camera);
	virtual void Update(float fElapsedTime);
	virtual bool CanFire();
	virtual void Fire(CCamera &camera);
	
protected:
	LPDIRECT3DVERTEXBUFFER8 m_pVBLaser;
  LPDIRECT3DINDEXBUFFER8 m_pIBLaser;
	CAnimSequence *m_pAnim;
	CParticleEmitter m_Emitter;
	D3DXMATRIX m_matWorld;
  
	bool m_bIsFiring;
	
};